/*
 * AutoUtils
 *
 */

/* 	$Id: autoutils.c,v 2.0 1994/03/01 06:54:53 flan Rel $	 */

#ifndef lint
static char vcid[] = "$Id: autoutils.c,v 2.0 1994/03/01 06:54:53 flan Rel $";
#endif /* lint */

#include <stdio.h>
#include "config.h"
#include "copyright.h"

#include "Wlib.h"
#include "defs.h"
#include "struct.h"
#include "data.h"
#include "packets.h"

#include "bot.h"

void
auto_shield_toggle(int up)
{
  if (!autoShieldEnabled)
    return;
  if ((me->p_status == PDEAD) || (me->p_status == PEXPLODE))
    return;
/*  if (userShield)
    return;
*/	
  if (up)
    {
      if(me->p_flags & PFBEAMDOWN) return;
      if(me->p_flags & PFBOMB) return;
      shield_up();
    }
  else
    {
      shield_down();
    }
}

void
AutoShield( void )
{
  register int h,i,dx,dy,dist;
  register struct torp *k;
  register struct player *j;
  register struct planet *pl;
  register struct plasmatorp *pt;
  register int up = 0;
  struct Enemy *enemy_buf;
  
  if (!autoShieldEnabled)
    return;

  for (i = 0, j = &players[i]; i < MAXPLAYER; i++, j++)
    {
      if(j->p_ntorp)
	{
	  for (h = 0, k = &torps[MAXTORP * i + h]; h < MAXTORP; h++, k++)
	    {
	      if (k->t_owner != me->p_no &&
		  ((k->t_war & me->p_team) ||
		  (players[k->t_owner].p_team & (me->p_hostile | me->p_swar))))
		{
		  if (k->t_status == TFREE)
		    continue;
		  dx = k->t_x - me->p_x;
		  dy = k->t_y - me->p_y;
		  dist = dx*dx + dy*dy;
		  if (dist <= autoShieldDist*autoShieldDist)
		    up = 1;
		}
	    }
	}
      
      if (!j->p_nplasmatorp)
	continue;
      for (h = 0, pt = &plasmatorps[MAXPLASMA * i + h];
	   h < MAXPLASMA;
	   h++, pt++)
	{
	  if (!pt->pt_status)
	    continue;
	  if (pt->pt_owner != me->p_no &&
	      ((pt->pt_war & me->p_team) ||
	       (players[pt->pt_owner].p_team & (me->p_hostile | me->p_swar))))
	    {
	      dx = pt->pt_x - me->p_x;
	      dy = pt->pt_y - me->p_y;
	      dist = dx*dx + dy*dy;
	      if (dist <= autoShieldDist*autoShieldDist)
		up = 1;
	    }
	}
    }
  
  enemy_buf = (struct Enemy *) get_nearest(0);
  if ((enemy_buf != 0) && (enemy_buf != NOENEMY))
    {
      j = &players[enemy_buf->e_info];
      if(enemy_buf->e_dist <= PHASEDIST * j->p_ship.s_phaserdamage / 100)
	{
	  up = 1;
	}
    }
  pl = (struct planet *) closest_planet(me);
  if(pl != NULL)
    {
      dx = (pl->pl_x - me->p_x) / 100;
      dy = (pl->pl_y - me->p_y) / 100;
      dist = dx*dx + dy*dy;
      if (dist <= PFIREDIST*PFIREDIST/10000 + 4)
	{
	  if (!(pl->pl_info & me->p_team))
	    {
	      up = 1;
	    }
	  else
	    {
	      if ((pl->pl_owner != me->p_team) &&
		  (pl->pl_owner & me->p_hostile))
		{
		  up = 1;
		}
	    }
	}
    }
  auto_shield_toggle(up);
}

void
AutoTorp( void )
{
  struct Enemy *mine;

  if (me->p_ntorp >= 6) return;
  if (me->p_fuel < me->p_ship.s_maxfuel/2) return;

  mine = (struct Enemy *)get_nearest(1);
  if ((mine != 0) && (mine != NOENEMY))
    {
      if (mine->e_tcourse && mine->e_dist<PHASEDIST*3/2)
	{
	  sendTorpReq (mine->e_tcourse);
	}
    }
}


/*
void
AutoTorpPlayer( int player )
{
  struct Enemy *mine;
  
  if (me->p_ntorp) >= 6
    return;
  if (me->p_fuel < me->p_ship.s_maxfuel/2) return;

  mine = (struct Enemy *)get_nearest(1);
  if ((mine != 0) && (mine != NOENEMY))
    {
      if (mine->e_tcourse && mine->e_dist<PHASEDIST*3/2)
	{
	  sendTorpReq (mine->e_tcourse);
	}
    }
}
*/ 
  

void
AutoPhaser(void)
{
	struct Enemy *mine;

	if (me->p_fuel < me->p_ship.s_maxfuel*2/3) return;

	mine = (struct Enemy *)get_nearest(1);
	if ((mine != 0) && (mine != NOENEMY))
	    if (mine->e_course && mine->e_dist<PHASEDIST/2) sendPhaserReq (mine->e_course);
}
