/*
 * smessage.c
 */
#include "config.h"
#include "copyright.h"

#include <stdio.h>
#include <math.h>
#include <signal.h>
#include <ctype.h>
#include "Wlib.h"
#include "defs.h"
#include "struct.h"
#include "data.h"

/* XFIX */
#define BLANKCHAR(col, n) W_ClearArea(messagew, 5+W_Textwidth*(col), 5, \
    W_Textwidth * (n), W_Textheight);
#define DRAWCURSOR(col) W_WriteText(messagew, 5+W_Textwidth*(col), 5, \
    textColor, &cursor, 1, W_RegularFont);
#define TESTCAP(c,s)	(c ? strcap(s) : s)

static int lcount;
static char buf[80];
static char cursor = '_';
char mbuf[80];
char *getaddr (), *getaddr2 ();

smessage (ichar)
     char ichar;
{
  int i;
  char *getaddr ();
  char twochar[2];
  static char addr, *addr_str;

  if (messpend == 0)
    {
      messpend = 1;
      /* Put the proper recipient in the window */
      if ((ichar == 't') || (ichar == 'T'))
	addr = teamlet[me->p_team];
      else
	addr = ichar;
      addr_str = getaddr (addr);
      if (addr_str == 0)
	{
	  /* print error message */
	  messpend = 0;
	  message_off ();
	  return;
	}
      strcat (outmessage, addr_str);
      lcount = ADDRLEN;
      DRAWCURSOR (ADDRLEN);
      while (strlen (outmessage) < ADDRLEN)
	{
	  strcat (outmessage, " ");
	}
      strcat (outmessage, "_");
#ifdef BRMH
      W_WriteText (messagew, 5, 5, textColor,
                   outmessage, strlen (outmessage), W_RegularFont);
#endif
      return;
    }

  if (ichar == ((char) ('h' + 96)) || ichar == ((char) ('H' + 96)))
    ichar = '\b';
  else if (ichar == ((char) ('[' + 96)))
    ichar = '\033';
  else if (ichar == ((char) ('m' + 96)) || ichar == ((char) ('M' + 96)))
    ichar = '\r';
  else if (ichar == ((char) ('j' + 96)) || ichar == ((char) ('J' + 96)))
    ichar = '\r';
  else if (ichar == ((char) ('u' + 96)) || ichar == ((char) ('U' + 96)))
    ichar = 23;

  switch ((unsigned char) ichar & ~(0x80))
    {
    case '\b':			/* character erase */
    case '\177':
      if (--lcount < ADDRLEN)
	{
	  lcount = ADDRLEN;
	  break;
	}
      BLANKCHAR (lcount + 1, 1);
      DRAWCURSOR (lcount);
      outmessage[lcount + 1] = '\0';
      outmessage[lcount] = cursor;
      break;

    case '\033':		/* abort message */
      BLANKCHAR (0, lcount + 1);
      mdisplayed = 0;
      messpend = 0;
      message_off ();
      for (i = 0; i < 80; i++)
	{
	  outmessage[i] = '\0';
	}
      break;

    case 23:
      while (--lcount >= ADDRLEN)
	{
	  BLANKCHAR (lcount + 1, 1);
	  DRAWCURSOR (lcount);
	  outmessage[lcount + 1] = '\0';
	  outmessage[lcount] = cursor;
	}
      lcount = ADDRLEN;
      break;
    case '\r':			/* send message */
      buf[lcount - ADDRLEN] = '\0';
      messpend = 0;
      for (i = 0; i < 80; i++)
	{
	  outmessage[i] = '\0';
	}
      switch (addr)
	{
	case 'A':
	  pmessage (buf, 0, MALL);
	  break;
	case 'F':
	  pmessage (buf, FED, MTEAM);
	  break;
	case 'R':
	  pmessage (buf, ROM, MTEAM);
	  break;
	case 'K':
	  pmessage (buf, KLI, MTEAM);
	  break;
	case 'O':
	  pmessage (buf, ORI, MTEAM);
	  break;
	case 'G':
	  pmessage (buf, 0, MGOD);
	  break;
#ifdef TOOLS
	case '!':
	  pmessage (buf, 0, MTOOLS);
	  break;
#endif
	case 'M':
	  pmessage (buf, 0, MMOO);
	  break;
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
	  if (players[addr - '0'].p_status == PFREE)
	    {
	      warning ("That player left the game. message not sent.");
	      return 0;
	    }
	  pmessage (buf, addr - '0', MINDIV);
	  break;
	case 'a':
	case 'b':
	case 'c':
	case 'd':
	case 'e':
	case 'f':
	case 'g':
	case 'h':
	case 'i':
	case 'j':
	case 'k':
	case 'l':
	case 'm':
	case 'n':
	case 'o':
	case 'p':
	case 'q':
	case 'r':
	case 's':
	case 't':
	case 'u':
	case 'v':
	case 'w':
	case 'x':
	case 'y':
	case 'z':
	  if (players[addr - 'a' + 10].p_status == PFREE)
	    {
	      warning ("That player left the game. message not sent.");
	      return 0;
	    }
	  pmessage (buf, addr - 'a' + 10, MINDIV);
	  break;
	default:
	  warning ("Not legal recipient");
	}
      BLANKCHAR (0, lcount + 1);
      mdisplayed = 0;
      lcount = 0;
      break;

    default:			/* add character */
      if (lcount >= 80)
	{
	  W_Beep ();
	  break;
	}
      if (iscntrl ((unsigned char) ichar & ~(0x80)))
	break;
      twochar[0] = ichar;
      twochar[1] = cursor;
      W_WriteText (messagew, 5 + W_Textwidth * lcount, 5, textColor,
		   twochar, 2, W_RegularFont);
      outmessage[lcount] = ichar;
      outmessage[lcount + 1] = cursor;
      buf[(lcount++) - ADDRLEN] = ichar;
      break;
    }
}

pmessage (str, recip, group)
     char *str;
     int recip;
     int group;
{
  char newbuf[100];

  /* message length failsafe and last message saving - jn 6/17/93 */
  lastMessage[0] = '\0';
  strncat (lastMessage, str, 79);
  str = lastMessage;

  switch (group) {
#ifdef TOOLS
  case MTOOLS:
    sendTools (str);
    break;
#endif
  case MMOO:
    strcpy (defaultsFile, str);
    sprintf (mbuf, "changing defaultsFile to %s", str);
    warning (mbuf);
    break;
  default:
    sendMessage (str, group, recip);
  }

  if ((group == MTEAM && recip != me->p_team) ||
      (group == MINDIV && recip != me->p_no))
    {
      sprintf (newbuf, "%s  %s", getaddr2 (group, recip), str);
      newbuf[79] = 0;
      dmessage (newbuf, group, me->p_no, recip);
    }
  message_off ();
}

char *
getaddr (who)
     char who;
{
  switch (who)
    {
    case 'A':
      return (getaddr2 (MALL, 0));
    case 'F':
      return (getaddr2 (MTEAM, FED));
    case 'R':
      return (getaddr2 (MTEAM, ROM));
    case 'K':
      return (getaddr2 (MTEAM, KLI));
    case 'O':
      return (getaddr2 (MTEAM, ORI));
    case 'G':
      return (getaddr2 (MGOD, 0));
    case 'M':
      return (getaddr2 (MMOO, 0));
#ifdef TOOLS
    case '!':
      return (getaddr2 (MTOOLS, 0));
#endif
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
      if (players[who - '0'].p_status == PFREE)
	{
	  warning ("Slot is not alive.");
	  return 0;
	}
      return (getaddr2 (MINDIV, who - '0'));
      break;
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':
      if (who - 'a' + 10 > MAXPLAYER)
	{
	  warning ("Player is not in game");
	  return (0);
	}
      if (players[who - 'a' + 10].p_status == PFREE)
	{
	  warning ("Slot is not alive.");
	  return 0;
	}

      return (getaddr2 (MINDIV, who - 'a' + 10));
      break;
    default:
      warning ("Not legal recipient");
      return (0);
    }
}

char *
getaddr2 (flags, recip)
     int flags;
     int recip;
{
  static char addrmesg[ADDRLEN];

  (void) sprintf (addrmesg, " %c%c->", teamlet[me->p_team], shipnos[me->p_no]);
  switch (flags)
    {
    case MALL:
      (void) sprintf (&addrmesg[5], "ALL");
      break;
    case MTEAM:
      (void) sprintf (&addrmesg[5], teamshort[recip]);
      break;
    case MINDIV:
      if (maskrecip)
	{
	  (void) sprintf (&addrmesg[5], "?? ");
	  maskrecip = 0;
	}
      else
	(void) sprintf (&addrmesg[5], "%c%c ",
			teamlet[players[recip].p_team], shipnos[recip]);
      break;
    case MGOD:
      (void) sprintf (&addrmesg[5], "GOD");
      break;
#ifdef TOOLS
    case MTOOLS:
      (void) sprintf (addrmesg, "COW: sh>");
      break;
#endif
    case MMOO:
      (void) sprintf (&addrmesg[5], "MOO");
      break;
    }
  return (addrmesg);
}

message_on ()
{
  messageon = 1;
  W_DefineTextCursor (w);
  W_DefineTextCursor (mapw);
}

message_off ()
{
  messageon = 0;
  W_DefineLocalcursor (w);
  W_DefineMapcursor (mapw);
}

/* Used in NEWMACRO, useful elsewhere also */
int
getgroup (addr, recip)
     char addr;
     int *recip;
{
  *recip = 0;

  switch (addr)
    {
    case 'A':
      *recip = 0;
      return (MALL);
      break;
    case 'F':
      *recip = FED;
      return (MTEAM);
      break;
    case 'R':
      *recip = ROM;
      return (MTEAM);
      break;
    case 'K':
      *recip = KLI;
      return (MTEAM);
      break;
    case 'O':
      *recip = ORI;
      return (MTEAM);
      break;
    case 'G':
      *recip = 0;
      return (MGOD);
      break;
#ifdef TOOLS
    case '!':
      *recip = 0;
      return (MTOOLS);
      break;
#endif
    case 'M':
      *recip = 0;
      return (MMOO);
      break;
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
      if (players[addr - '0'].p_status == PFREE)
	{
	  warning ("That player left the game. message not sent.");
	  return 0;
	}
      *recip = addr - '0';
      return (MINDIV);
      break;
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
    case 'g':
    case 'h':
    case 'i':
    case 'j':
    case 'k':
    case 'l':
    case 'm':
    case 'n':
    case 'o':
    case 'p':
    case 'q':
    case 'r':
    case 's':
    case 't':
    case 'u':
    case 'v':
    case 'w':
    case 'x':
    case 'y':
    case 'z':
      if (players[addr - 'a' + 10].p_status == PFREE)
	{
	  warning ("That player left the game. message not sent.");
	  return 0;
	}
      *recip = addr - 'a' + 10;
      return (MINDIV);
      break;
    default:
      warning ("Not legal recipient");
    }
  return 0;
}


pnbtmacro (c)
     int c;
{
  switch (macro[c].who)
    {
    case 'A':
      pmessage (macro[c].string, 0, MALL);
      break;
    case 'F':
      pmessage (macro[c].string, FED, MTEAM);
      break;
    case 'R':
      pmessage (macro[c].string, ROM, MTEAM);
      break;
    case 'K':
      pmessage (macro[c].string, KLI, MTEAM);
      break;
    case 'O':
      pmessage (macro[c].string, ORI, MTEAM);
      break;
    case 'T':
      pmessage (macro[c].string, me->p_team, MTEAM);
      break;
    }
}

/* the primary subroutine for newmacro, converts the strange and wonderful
   ** newmacro syntax into an actual message.
   ** This is about as inefficient as they come, but how often is the player
   ** going to send a macro??
   **  6/3/93 - jn
 */
#ifdef nodef
pmacro (mnum, who, data)
     int mnum;
     char who;
     W_Event *data;
{
  char buf1[10 * MAXMACLEN];
  char buf2[10 * MAXMACLEN];
  char buf3[10 * MAXMACLEN];
  char tmp[10 * MAXMACLEN];
  char *pm;
  char *pbuf2;
  char ctmp;
  int index = 0;
  int index2 = 0;
  int index3 = 0;
  int recip;
  int group;
  char *getaddr ();
  char addr;
  char *addr_str;
  int state = 0;
  int cap = 0;
  int team = 0;
  struct player *j;
  struct planet *l;
  struct obtype *gettarget (), *gettarget2 (), *target;
  int targettype = 0;
  char *pos;
  char *strcap ();
  extern int ping_iloss_sc;	/* inc % loss 0--100, server to client */
  extern int ping_iloss_cs;	/* inc % loss 0--100, client to server */
  extern int ping_tloss_sc;	/* total % loss 0--100, server to client */
  extern int ping_tloss_cs;	/* total % loss 0--100, client to server */
  extern int ping_lag;		/* delay in ms of last ping */
  extern int ping_av;		/* average rt */
  extern int ping_sd;		/* standard deviation */



  if (!UseNewMacro)
    return 0;

  /* get recipient and group */
  if ((who == 't') || (who == 'T'))
    addr = teamlet[me->p_team];
  else
    addr = who;

  group = getgroup (addr, &recip);

  if (!group)
    {
      printf ("Bad group!\n");
      return (0);
    }


  pm = macro[mnum].string;

  buf1[0] = '\0';

  /* first step is to substitute variables */
  while (*pm)
    {
      if (state)
	{
	  switch (*(pm++))
	    {
	    case 'a':		/* push army number into buf */
	      sprintf (tmp, "%d\0", me->p_armies);
	      strcat (buf1, tmp);
	      state = 0;
	      continue;
	      break;
	    case 'd':		/* push damage into buf */
	      sprintf (tmp, "%d", (100 * me->p_damage) / me->p_ship.s_maxdamage);
	      strcat (buf1, tmp);
	      state = 0;
	      continue;
	    case 's':		/* push shields into buf */
	      sprintf (tmp, "%d", (100 * me->p_shield) / me->p_ship.s_maxshield);
	      strcat (buf1, tmp);
	      state = 0;
	      continue;
	      break;
	      break;
	    case 'f':		/* push fuel into buf */
	      sprintf (tmp, "%d", (100 * me->p_fuel) / me->p_ship.s_maxfuel);
	      strcat (buf1, tmp);
	      state = 0;
	      continue;
	      break;
	    case 'w':		/* push wtemp into buf */
	      sprintf (tmp, "%d", (100 * me->p_wtemp) / me->p_ship.s_maxwpntemp);
	      strcat (buf1, tmp);
	      state = 0;
	      continue;
	      break;
	    case 'e':		/* push etemp into buf */
	      sprintf (tmp, "%d", (100 * me->p_etemp) / me->p_ship.s_maxegntemp);
	      strcat (buf1, tmp);
	      state = 0;
	      continue;
	      break;

	    case 'p':		/* push player id into buf */
	      targettype = TARG_PLAYER;
	    case 'g':		/* push player id into buf */
	      if (!targettype)
		targettype = TARG_FRIEND;
	    case 'h':		/* push player id into buf */
	      if (!targettype)
		targettype = TARG_ENEMY;

	      target = gettarget (data->Window, data->x, data->y, targettype);

	      if (target->o_type == PLAYERTYPE)
		{
		  j = &players[target->o_num];
		  tmp[0] = j->p_mapchars[1];
		  tmp[1] = '\0';
		  strcat (buf1, tmp);
		}

	      targettype = 0;
	      state = 0;
	      continue;
	      break;

	    case 'n':		/* push planet armies into buf */
	      target = gettarget (data->Window, data->x, data->y,
				  TARG_PLANET);
	      if (target->o_type == PLANETTYPE)
		{
		  l = &planets[target->o_num];
		  if (l->pl_info & me->p_team)
		    sprintf (tmp, "%d\0", l->pl_armies);
		  else
		    sprintf (tmp, "%d\0", -1);
		  strcat (buf1, tmp);
		}
	      state = 0;
	      continue;
	      break;
	    case 'B':
	      cap = 1;
	    case 'b':		/* push planet into buf */
	      target = gettarget2 (me->p_x, me->p_y, TARG_PLANET);
	      if (target->o_type == PLANETTYPE)
		{
		  l = &planets[target->o_num];
		  tmp[0] = l->pl_name[0] - 'A' + 'a';
		  tmp[1] = l->pl_name[1];
		  tmp[2] = l->pl_name[2];
		  tmp[3] = '\0';
		  strcat (buf1, TESTCAP (cap, tmp));
		}
	      cap = 0;
	      state = 0;
	      continue;
	      break;
	    case 'L':
	      cap = 1;
	    case 'l':		/* push planet into buf */
	      target = gettarget (data->Window, data->x, data->y,
				  TARG_PLANET);
	      if (target->o_type == PLANETTYPE)
		{
		  l = &planets[target->o_num];
		  tmp[0] = l->pl_name[0] - 'A' + 'a';
		  tmp[1] = l->pl_name[1];
		  tmp[2] = l->pl_name[2];
		  tmp[3] = '\0';
		  strcat (buf1, TESTCAP (cap, tmp));
		}
	      cap = 0;
	      state = 0;
	      continue;
	      break;
	    case 'Z':		/* push a 3 character team name into buf */
	      cap = 1;
	    case 'z':		/* push a 3 character team name into buf */
	      target = gettarget (data->Window, data->x, data->y,
				  TARG_PLAYER | TARG_PLANET);
	      if (target->o_type == PLANETTYPE)
		{
		  l = &planets[target->o_num];
		  team = l->pl_owner;
		}
	      else if (target->o_type == PLAYERTYPE)
		{
		  j = &players[target->o_num];
		  team = j->p_team;
		}
	      else
		team = 3;	/* send "X", might just make the guy correct it */
	      strcat (buf1, TESTCAP (cap, teamshort[team]));
	      state = 0;
	      cap = 0;
	      continue;
	      break;
	    case 't':		/* push a team character into buf */
	      target = gettarget (data->Window, data->x, data->y,
				  TARG_PLAYER | TARG_PLANET);
	      if (target->o_type == PLANETTYPE)
		{
		  l = &planets[target->o_num];
		  tmp[0] = teamlet[l->pl_owner];
		}
	      else if (target->o_type == PLAYERTYPE)
		{
		  j = &players[target->o_num];
		  tmp[0] = j->p_mapchars[0];
		}
	      else
		tmp[0] = '\0';
	      tmp[1] = '\0';
	      strcat (buf1, tmp);
	      state = 0;
	      continue;
	      break;
	    case 'T':		/* push my team into buf */
	      tmp[0] = me->p_mapchars[0];
	      tmp[1] = '\0';
	      strcat (buf1, tmp);
	      state = 0;
	      continue;
	      break;
	    case 'c':		/* push my id char into buf */
	      tmp[0] = me->p_mapchars[1];
	      tmp[1] = '\0';
	      strcat (buf1, tmp);
	      state = 0;
	      continue;
	      break;
	    case 'W':		/* push WTEMP flag into buf */
	      if (me->p_flags & PFWEP)
		tmp[0] = '1';
	      else
		tmp[0] = '0';
	      tmp[1] = '\0';
	      strcat (buf1, tmp);
	      state = 0;
	      continue;
	      break;
	    case 'E':		/* push ETEMP flag into buf */
	      if (me->p_flags & PFENG)
		tmp[0] = '1';
	      else
		tmp[0] = '0';
	      tmp[1] = '\0';
	      strcat (buf1, tmp);
	      state = 0;
	      continue;
	      break;
	    case 'M':		/* push capitalized lastMessage into buf */
	      cap = 1;
	    case 'm':		/* push lastMessage into buf */
	      strncat (buf1, TESTCAP (cap, lastMessage), 79);
	      state = 0;
	      cap = 0;
	      continue;
	      break;
	    case 'U':		/* push player name into buf */
	      cap = 1;
	    case 'u':		/* push player name into buf */
	      target = gettarget (data->Window, data->x, data->y,
				  TARG_PLAYER);
	      j = &players[target->o_num];
	      strncat (buf1, TESTCAP (cap, j->p_name), 16);
	      state = 0;
	      cap = 0;
	      continue;
	      break;
	    case 'I':		/* my player name into buf */
	      cap = 1;
	    case 'i':		/* my player name into buf */
	      strncat (buf1, TESTCAP (cap, me->p_name), 16);
	      state = 0;
	      cap = 0;
	      continue;
	      break;
	    case 'S':		/* push ship type into buf */
	      strcat (buf1, classes[me->p_ship.s_type]);
	      state = 0;
	      continue;
	      break;
	    case 'v':		/* push average ping round trip time into buf */
	      sprintf (tmp, "%d", ping_av);
	      strcat (buf1, tmp);
	      state = 0;
	      continue;
	      break;
	    case 'V':		/* push ping stdev into buf */
	      sprintf (tmp, "%d", ping_sd);
	      strcat (buf1, tmp);
	      state = 0;
	      continue;
	      break;
	    case 'y':		/* push packet loss into buf */
	      /* this is the weighting formula used be socket.c ntserv */
	      sprintf (tmp, "%d", (2 * ping_tloss_sc + ping_tloss_cs) / 3);
	      strcat (buf1, tmp);
	      state = 0;
	      continue;
	      break;
	    case '}':		/* push %} into buf */
	      tmp[0] = '%';
	      tmp[1] = '}';
	      tmp[2] = '\0';
	      strcat (buf1, tmp);
	      state = 0;
	      continue;
	      break;
	    case '{':		/* push %{ into buf */
	      tmp[0] = '%';
	      tmp[1] = '{';
	      tmp[2] = '\0';
	      strcat (buf1, tmp);
	      state = 0;
	      continue;
	      break;
	    case '!':		/* push %! into buf */
	      tmp[0] = '%';
	      tmp[1] = '!';
	      tmp[2] = '\0';
	      strcat (buf1, tmp);
	      state = 0;
	      continue;
	      break;
	    case '?':		/* push %? into buf */
	      tmp[0] = '%';
	      tmp[1] = '?';
	      tmp[2] = '\0';
	      strcat (buf1, tmp);
	      state = 0;
	      continue;
	      break;
	    case '%':		/* push %% into buf */
	      tmp[0] = '%';
	      if (UseSmartMacro)
		tmp[1] = '%';
	      tmp[2] = '\0';
	      strcat (buf1, tmp);
	      state = 0;
	      continue;
	      break;
	    default:
	      warning ("Bad Macro character in macro.");
	      printf ("Unrecognizable special character in macro pass 1: %c\n", *pm);
	      return (0);
	    }
	}

      if (*pm == '%')
	{
	  state++;
	  pm++;
	  continue;
	}

      state = 0;

      tmp[0] = *pm;
      tmp[1] = '\0';
      strcat (buf1, tmp);
      pm++;
    }

  if (!UseSmartMacro)
    {
      pmessage (buf1, recip, group);
    }
  else
    {
      /* second step is to evaluate tests, buf1->buf2 */
      testmacro (buf1, buf2, &index, &index2);
      buf2[index2] = '\0';

      index2 = 0;

      /* third step is to include conditional text, buf2->buf3 */
      condmacro (buf2, buf3, &index2, &index3, 1);
      buf3[index3] = '\0';

      pmessage (buf3, recip, group);
    }

  return (1);
}

#endif
